import { StitchCredential } from "mongodb-stitch-core-sdk";
import AuthProviderClientFactory from "./providers/internal/AuthProviderClientFactory";
import NamedAuthProviderClientFactory from "./providers/internal/NamedAuthProviderClientFactory";
import StitchAuthListener from "./StitchAuthListener";
import StitchUser from "./StitchUser";
export default interface StitchAuth {
    isLoggedIn: boolean;
    user?: StitchUser;
    listUsers(): StitchUser[];
    switchToUserWithId(userId: string): StitchUser;
    getProviderClient<ClientT>(factory: AuthProviderClientFactory<ClientT>): ClientT;
    getProviderClient<T>(factory: NamedAuthProviderClientFactory<T>, providerName: string): T;
    loginWithCredential(credential: StitchCredential): Promise<StitchUser>;
    logout(): Promise<void>;
    logoutUserWithId(userId: string): Promise<void>;
    removeUser(): Promise<void>;
    removeUserWithId(userId: string): Promise<void>;
    addAuthListener(listener: StitchAuthListener): any;
    removeAuthListener(listener: StitchAuthListener): any;
}
