import { StitchAppClientConfiguration } from "mongodb-stitch-core-sdk";
import NamedServiceClientFactory from "../../services/internal/NamedServiceClientFactory";
import ServiceClientFactory from "../../services/internal/ServiceClientFactory";
import StitchServiceClient from "../../services/StitchServiceClient";
import StitchAuthImpl from "../auth/internal/StitchAuthImpl";
import StitchAuth from "../auth/StitchAuth";
import StitchUser from "../auth/StitchUser";
import StitchAppClient from "../StitchAppClient";
export default class StitchAppClientImpl implements StitchAppClient {
    readonly auth: StitchAuthImpl;
    private readonly coreClient;
    private readonly info;
    private readonly routes;
    private serviceClients;
    constructor(clientAppId: string, config: StitchAppClientConfiguration);
    getServiceClient<T>(factory: ServiceClientFactory<T> | NamedServiceClientFactory<T>, serviceName?: string): T;
    getGeneralServiceClient(serviceName: string): StitchServiceClient;
    callFunction(name: string, args: any[]): Promise<any>;
    onActiveUserChanged(_: StitchAuth, currentActiveUser: StitchUser | undefined, previousActiveUser: StitchUser | undefined): void;
    close(): void;
    private bindServiceClient;
    private onRebindEvent;
}
